#-----------------------------------------------------------------------------
'''
 Naturalizer script
 January 15, 2003
 Modernized 9/10/05
 Revised 2/10/06 to include Jessi and James default expressions
 Revised 8/04/07 for P7 version changes (float/int fussiness)
 Revised 2/25/08 to crank up some values for newer figures,
 and to add Waist for P7 figures.


 Copyright (c) 2007, David G. Drumright (ockham)

	Purpose:  Generates natural wiggles and blinks, so that a character
	will appear to be alive when not making any big purposeful moves.

'''

#-----------------------------------------------------------------------------


#-----------------------------------------------------------------------------

from Tkinter import *
import random
import poser
scene = poser.Scene()

#-----------------------------------------------------------------------------
global TheFigure
global TheHead
global Intensity
global Speed
global SecondsBetweenBlinks
global SecondsBetweenBreaths
global BlinkVariation
global SecondsBetweenGlances
global FramesBetweenGlances
global SecondsWithinGlance
global FramesWithinGlance
global OpenVal
global CloseVal

global StartFrame
global EndFrame
global BlinksOn
global GlanceOn
global BreathOn

global NeckBProp
global NeckSProp
global FaceProp
global LegProp
global ShoulderProp
global ArmProp
global FingerProp
global GlanceProp

Intensity = 0.5 			# Controlled
Speed = 0.2 				# Controlled
SecondsBetweenBreaths = 1.0  # Controlled
SecondsBetweenBlinks = 2.0	# Controlled
SecondsBetweenGlances = 3.0 # Controlled
SecondsWithinGlance = 0.8 # Controlled
BlinkVariation = 1.0			   # not control panel
OpenVal =  0.2				  # not control panel
CloseVal = 1.2				  # not control panel

BlinksOn = 0 # action flag
GlanceOn = 0 # action flag
BreathOn = 0 # action flag

# Default values
StartFrame=1
EndFrame=scene.NumFrames()


#-----------------------------------------------------------------------------
# Get necessaries and find the Figure before getting under way.
#-----------------------------------------------------------------------------
TheFigure=0
try:
	TheFigure = scene.CurrentFigure()  # use currently selected TheFigure
except:
	raise "No figure selected!"
if not TheFigure:
	raise "No figure selected!"

TheHead=TheFigure.Actor("Head")

ShoulderActors=["rCollar","lCollar","rShldr","lShldr"]

ShoulderParms =[poser.kParmCodeXROT,poser.kParmCodeYROT,poser.kParmCodeZROT]

ArmActors =    ["rForeArm","lForeArm","rHand","lHand"]

ArmParms =	   [poser.kParmCodeXROT,poser.kParmCodeZROT]

LegActors =    ["lThigh","rThigh","lShin","rShin","rFoot","lFoot","rToe","lToe"]
LegParms =	   [poser.kParmCodeXROT,poser.kParmCodeYROT]

LeftFingers =  ["Left Thumb 1",  "Left Thumb 2",  "Left Thumb 3",
				"Left Index 1",  "Left Index 2",  "Left Index 3",
				"Left Mid 1",    "Left Mid 2",    "Left Mid 3",
				"Left Ring 1",   "Left Ring 2",   "Left Ring 3",
				"Left Pinky 1",  "Left Pinky 2",  "Left Pinky 3"]
RightFingers = ["Right Thumb 1", "Right Thumb 2", "Right Thumb 3",
				"Right Index 1", "Right Index 2", "Right Index 3",
				"Right Mid 1",   "Right Mid 2",   "Right Mid 3",
				"Right Ring 1",  "Right Ring 2",  "Right Ring 3",
				"Right Pinky 1", "Right Pinky 2", "Right Pinky 3"]

FingerParms =  [poser.kParmCodeXROT]

FaceParmsDefault = ['Mouth O','Mouth M','Mouth F','OpenLips','Smile','Frown',
					'RBrowDown','LBrowDown','RBrowUp','LBrowUp','Worry Right','Worry Left',
					'mouthM', 'mouthO', 'mouthF', 'MouthOpen', 'EyesWorry','BrowUpRight', 'BrowUpLeft']

#-----------------------------------------------------------------------------

def SetupVars():  # After we've picked up the sliders
	global Intensity
	global Speed
	global FramesBetweenBlinks
	global SecondsBetweenBlinks
	global FramesBetweenBreaths
	global SecondsBetweenBreaths
	global BlinkVariation
	global SecondsBetweenGlances
	global SecondsWithinGlance
	global FramesWithinGlance
	global OpenVal
	global CloseVal

	global NeckBProp
	global NeckSProp
	global FaceProp
	global LegProp
	global ShoulderProp
	global ArmProp
	global FingerProp
	global GlanceProp

	# Prorate the blink rate and the Intensity by actual frames
	# per second.

	fps = scene.FramesPerSecond()

	# Turn Sec/Blink into Frames/Blink:
	FramesBetweenBlinks = SecondsBetweenBlinks * float(fps)
	FramesBetweenBreaths = SecondsBetweenBreaths * float(fps)

	FramesBetweenGlances = SecondsBetweenGlances * float(fps)
	FramesWithinGlance	 = SecondsWithinGlance	 * float(fps)

	Intensity = Intensity * 10.0 / float(fps)

	# Now set the various subprops

	BreathProp = 2.0 * Intensity

	NeckBProp = 3.0 * Intensity

	NeckSProp = 3.0 * Intensity

	FaceProp = 2.5 * Intensity

	LegProp = 0.1 * Intensity

	ShoulderProp = 1.5 * Intensity

	ArmProp = 4.0 * Intensity

	FingerProp = 10.0 * Intensity

	GlanceProp = 40.0 * Intensity

	# Fix the max and min limits for default face parms.
	# If you use your own choices, you'll have to set your
	# own max and min.

	try:
	  P = TheHead.Parameter("Mouth O")
	  P.SetMinValue( -1.0)
	  P.SetMaxValue(  0.8)
	except:
	  pass

	try:
	  P = TheHead.Parameter("mouthO")
	  P.SetMinValue( -1.0)
	  P.SetMaxValue(  0.8)
	except:
	  pass
	try:
	  P = TheHead.Parameter("mouthM")
	  P.SetMinValue( -0.3)
	  P.SetMaxValue(  0.1)
	except:
	  pass

	try:
	  P = TheHead.Parameter("Mouth M")
	  P.SetMinValue(-0.3)
	  P.SetMaxValue( 0.1)
	except:
	  pass

	try:
	  P = TheHead.Parameter("Mouth F")
	  P.SetMinValue( -0.2)
	  P.SetMaxValue(  0.5)
	except:
	  pass

	try:
	  P = TheHead.Parameter("mouthF")
	  P.SetMinValue( -0.2)
	  P.SetMaxValue(  0.5)
	except:
	  pass

	try:
	  P = TheHead.Parameter("OpenLips")
	  P.SetMinValue(  0.0)
	  P.SetMaxValue(  1.0)
	except:
	  pass

	try:
	  P = TheHead.Parameter("MouthOpen")
	  P.SetMinValue(  0.0)
	  P.SetMaxValue(  1.0)
	except:
	  pass

	try:
	  P = TheHead.Parameter("Smile")
	  P.SetMinValue( -1.8)
	  P.SetMaxValue(  0.7)
	except:
	  pass

	try:
	  P = TheHead.Parameter("Frown")
	  P.SetMinValue( -1.0)
	  P.SetMaxValue(  1.0)
	except:
	  pass

	try:
	  P = TheHead.Parameter("RBrowDown")
	  P.SetMinValue( -2.0)
	  P.SetMaxValue(  1.0)
	except:
	  pass

	try:
	  P = TheHead.Parameter("LBrowDown")
	  P.SetMinValue( -2.0)
	  P.SetMaxValue(  1.0)
	except:
	  pass

	try:
	  P = TheHead.Parameter("RBrowUp")
	  P.SetMinValue( -2.0)
	  P.SetMaxValue(  1.0)
	except:
	  pass
	try:
	  P = TheHead.Parameter("BrowUpRight")
	  P.SetMinValue( -2.0)
	  P.SetMaxValue(  1.0)
	except:
	  pass

	try:
	  P = TheHead.Parameter("LBrowUp")
	  P.SetMinValue( -2.0)
	  P.SetMaxValue(  1.0)
	except:
	  pass
	try:
	  P = TheHead.Parameter("BrowUpLeft")
	  P.SetMinValue( -2.0)
	  P.SetMaxValue(  1.0)
	except:
	  pass

	try:
	  P = TheHead.Parameter("Worry Right")
	  P.SetMinValue( -1.0)
	  P.SetMaxValue(  1.0)
	except:
	  pass

	try:
	  P = TheHead.Parameter("EyesWorry")
	  P.SetMinValue( -1.0)
	  P.SetMaxValue(  1.0)
	except:
	  pass

	try:
	  P = TheHead.Parameter("Worry Left")
	  P.SetMinValue( -1.0)
	  P.SetMaxValue(  1.0)
	except:
	  pass

	try:
	  P = TheHead.Parameter("Blink Right")
	  P.SetMinValue(OpenVal)
	  P.SetMaxValue(CloseVal)
	except:
	  pass

	try:
	  P = TheHead.Parameter("Blink Left")
	  P.SetMinValue(OpenVal)
	  P.SetMaxValue(CloseVal)
	except:
	  pass

	try:
	  P = TheHead.ParameterByCode(poser.kParmCodeYROT)	# Twist
	  P.SetMinValue(-30.0)
	  P.SetMaxValue( 30.0)
	except:
	  pass

	try:
	  P = TheHead.ParameterByCode(poser.kParmCodeXROT)	# Bend
	  P.SetMinValue(-40.0)
	  P.SetMaxValue( 30.0)
	except:
	  pass

	try:
	  P = TheHead.ParameterByCode(poser.kParmCodeZROT)	# Side-Side
	  P.SetMinValue(-30.0)
	  P.SetMaxValue( 30.0)
	except:
	  pass

	try:
	  A = TheFigure.Actor("Neck")
	  P = A.ParameterByCode(poser.kParmCodeYROT)  # Twist
	  P.SetMinValue(-30.0)
	  P.SetMaxValue( 30.0)
	  P = A.ParameterByCode(poser.kParmCodeXROT)  # Bend
	  P.SetMinValue(-30.0)
	  P.SetMaxValue( 20.0)
	  P = A.ParameterByCode(poser.kParmCodeZROT)  # Side-Side
	  P.SetMinValue(-30.0)
	  P.SetMaxValue( 30.0)
	except:
	  pass


#-----------------------------------------------------------------------------
# Next section is the TK loop
#------------------------------------------------------------

class App:
	def __init__(self, master, textMessage):

		self.master = master
		self.master.title("Naturalizer")
		# Frames for list and buttons
		self.SliderFrame = Frame(self.master,borderwidth=2,relief=RIDGE)
		self.SliderFrame.grid( row=1,column=0,pady=1)
		self.ListFrame = Frame(self.master,borderwidth=2,relief=RIDGE)
		self.ListFrame.grid( row=1,column=1,pady=1)
		self.ButtonFrame = Frame(self.master,borderwidth=2,relief=RIDGE)
		self.ButtonFrame.grid( row=1,column=2,pady=1)

		# Status box
		self.StatusEntry=Entry(self.master,width=50)
		self.StatusEntry.grid(row=0,column=0,columnspan=3)
		self.StatusEntry.insert(0,"Pick the parameter[s] to blink both eyes, then set the sliders.")

		Label(self.SliderFrame, text="Main Intensity:" ).grid(row=1, sticky=W)
		self.IntensityEntry = Scale(self.SliderFrame, from_= 0.0, to=10.0,orient=HORIZONTAL,resolution=0.1)
		self.IntensityEntry.grid(row=1, column=1)
		self.IntensityEntry.set(5.0)

		Label(self.SliderFrame, text="Main Speed:" ).grid(row=2, sticky=W)
		self.SpeedEntry = Scale(self.SliderFrame, from_= 0.0, to=10.0,orient=HORIZONTAL,resolution=0.1)
		self.SpeedEntry.grid(row=2, column=1)
		self.SpeedEntry.set(0.5)

		Label(self.SliderFrame, text="Blinks per second:" ).grid(row=3, sticky=W)
		self.BlinkSpeedEntry = Scale(self.SliderFrame, from_= 0.0, to=2.0,orient=HORIZONTAL,resolution=0.05)
		self.BlinkSpeedEntry.grid(row=3, column=1)
		self.BlinkSpeedEntry.set(0.25)

		Label(self.SliderFrame, text="Glances per second:" ).grid(row=4, sticky=W)
		self.GlanceSpeedEntry = Scale(self.SliderFrame, from_= 0.0, to=2.0,orient=HORIZONTAL,resolution=0.05)
		self.GlanceSpeedEntry.grid(row=4, column=1)
		self.GlanceSpeedEntry.set(0.25)

		Label(self.SliderFrame, text="Breaths per second:" ).grid(row=5, sticky=W)
		self.BreathSpeedEntry = Scale(self.SliderFrame, from_= 0.0, to=2.0,orient=HORIZONTAL,resolution=0.05)
		self.BreathSpeedEntry.grid(row=5, column=1)
		self.BreathSpeedEntry.set(0.25)

		Label(self.SliderFrame, text="Start frame:" ).grid(row=6, column=0,sticky=W)
		self.StartEntry = Entry(self.SliderFrame,width=6)
		self.StartEntry.grid(row=6,  column=0,sticky=E)
		self.StartEntry.insert(0,str(StartFrame))

		Label(self.SliderFrame, text="End frame:" ).grid( row=6,column=1,sticky=W)
		self.EndEntry = Entry(self.SliderFrame,width=6)
		self.EndEntry.grid( row=6,column=1,sticky=E)
		self.EndEntry.insert(0,str(EndFrame))

		# Lists
		self.ParmListScroll = Scrollbar(self.ListFrame, orient=VERTICAL)
		self.ParmListScroll.grid( row=0, column=0,sticky=N+S+E)
		self.ParmListBox = Listbox(self.ListFrame, height=15, selectmode=MULTIPLE,yscrollcommand = self.ParmListScroll.set)
		self.ParmListBox.grid( row=0, column=1)
		# Set the scrollbar to work
		self.ParmListScroll["command"] = self.ParmListBox.yview
		# Fill this with all MTs on head
		for OneParm in TheHead.Parameters():
			if OneParm.IsMorphTarget():
				self.ParmListBox.insert(END,OneParm.Name())


		# buttons for 'modes' and cancel.
		self.buttonGo = Button(master, text="Go", command=self.HandleGo)
		self.buttonGo.grid(row=7, column=0)
		self.buttonCancel = Button(master, text="Cancel", command=self.HandleCancel)
		self.buttonCancel.grid(row=7, column=1)

	# - - - - - - - - - - - - - - - - - -
	def ShowStatus(self,S): # Just saving repetition
		self.StatusEntry.delete(0,END)
		self.StatusEntry.insert(0,S)
		self.StatusEntry.update_idletasks()

	# - - - - - - - - - - - - - - - - - -

	def GetControls(self):	# separate to shorten the Go parts
		global StartFrame
		global EndFrame
		global Intensity
		global Speed
		global SecondsBetweenBlinks
		global SecondsBetweenBreaths
		global SecondsBetweenGlances
		global BlinksOn
		global BreathOn
		global GlancesOn

		# Fetch the sliders:
		# init Intensity = 0.2; go from zero to 0.4 with entry 0 to 10.
		Is = self.IntensityEntry.get()
		if Is:
			Intensity =  float(Is) * 0.4 / 10.0
		else:
		   Intensity = 0.2

		# init Speed = 0.15; go from zero to 0.3 with entry 0 to 10.
		Sps = self.SpeedEntry.get()
		if Sps:
			Speed =  float(Sps) * 0.3 / 10.0
		else:
			Speed = 0.15

		# init BlinksPerSecond = 0.25; go from 0 to 2 with entry 0 to 2.
		BSs=self.BlinkSpeedEntry.get()
		if BSs:
		   BS =  float(BSs)
		else:
		   BS = 0.0

		if BS <= 0.0:
		   BlinksOn = 0  # Signal for no blinks at all
		else:
		   BlinksOn = 1
		   SecondsBetweenBlinks =  1.0 / BS

		# init BreathsPerSecond = 0.25; go from 0 to 2 with entry 0 to 2.
		BSs =  self.BreathSpeedEntry.get()
		if BSs:
			BS = float(BSs)
		else:
			BS = 0.25

		if BS <= 0.0:
		   BreathOn = 0  # Signal for no blinks at all
		else:
		   BreathOn = 1
		   SecondsBetweenBreaths =	1.0 / BS

		# init GlancesPerSecond = 0.25; go from 0 to 2 with entry 0 to 2.
		GSs = self.GlanceSpeedEntry.get()
		if GSs:
			GS = float(GSs)
		else:
			GS = 0.25

		if GS <= 0.0:
		   GlanceOn = 0  # Signal for no glance at all
		else:
		   GlanceOn = 1
		   SecondsBetweenGlances  = 1.0 / GS

		# Fetch the Start and End
		s=self.StartEntry.get()
		if s:
			StartFrame = int(s)
		s=self.EndEntry.get()
		if s:
			EndFrame = int(s)

		# Be sure these are in range:
		if StartFrame > scene.NumFrames(): StartFrame = scene.NumFrames()
		if EndFrame > scene.NumFrames(): EndFrame = scene.NumFrames()

	# - - - - - - - - - - - - - - - - - -
	# Run random moves for all frames
	#-----------------------------------------------------------------------------
	def RunNaturalizer(self):
		for i in range((StartFrame-1), (EndFrame-1)):
		  scene.SetFrame(i)
		  self.ShowStatus("Working frame %d" % i)

		  # Do face parts
		  if random.random() < Speed:
		   for ParmName in FaceParmsDefault:
			try:
			  P = TheHead.Parameter(ParmName)
			  R = FaceProp * random.random() - 0.5*FaceProp
			  P.SetValue(R+P.Value())
			  P.SetSplineBreak(i,1)
			except:
			  pass

		  # Now do neck and head bends
		  A = TheFigure.Actor("Neck")
		  if random.random() < Speed:
		   try:
			 P = A.ParameterByCode(poser.kParmCodeXROT)
			 R = NeckBProp * random.random() - 0.5*NeckBProp
			 P.SetValue(R+P.Value())
			 P.SetSplineBreak(i,1)
		   except:
			 pass

		  if random.random() < Speed:
		   try:
			 P = A.ParameterByCode(poser.kParmCodeZROT)
			 R = NeckSProp * random.random() - 0.5*NeckSProp
			 P.SetValue(R+P.Value())
			 P.SetSplineBreak(i,1)
		   except:
			 pass

		  if random.random() < Speed:
		   try:
			 P = A.ParameterByCode(poser.kParmCodeYROT)
			 R = NeckSProp * random.random() - 0.5*NeckSProp
			 P.SetValue(R+P.Value())
			 P.SetSplineBreak(i,1)
		   except:
			 pass

		  # Now do arms
		  if random.random() < Speed:
		   for ActorName in ShoulderActors:
			  try:
				A = TheFigure.Actor(ActorName)
				for ParmName in ShoulderParms:
				  P = A.ParameterByCode(ParmName)
				  R = ShoulderProp * random.random() - 0.5*ShoulderProp
				  P.SetValue(R+P.Value())
				  A.SetSplineBreak(i,1)
			  except:
				pass

		  if random.random() < Speed:
		   for ActorName in ArmActors:
			  try:
				A = TheFigure.Actor(ActorName)
				for ParmName in ArmParms:
				  P = A.ParameterByCode(ParmName)
				  R = ArmProp * random.random() - 0.5*ArmProp
				  P.SetValue(R+P.Value())
				  A.SetSplineBreak(i,1)
			  except:
				pass

		  # Now do leg Actors
		  if random.random() < Speed:
			 try:
			   for ActorName in LegActors:
				 A = TheFigure.Actor(ActorName)
				 for ParmName in LegParms:
				   P = A.ParameterByCode(ParmName)
				   R = LegProp * random.random() - 0.5*LegProp
				   P.SetValue(R+P.Value())
				   A.SetSplineBreak(i,1)
			 except:
			   pass

		  # Now do left fingers
		  if random.random() < Speed:
			  for ActorName in LeftFingers:
				  try:
					  A = TheFigure.Actor(ActorName)
					  for Parm in FingerParms:
						  P = A.ParameterByCode(Parm)
						  R = FingerProp * random.random() - 0.5*FingerProp
						  P.SetValue(R+P.Value())
				  except:
					  pass

		  # Now do right fingers
		  if random.random() < Speed:
			  for ActorName in RightFingers:
				  try:
					  A = TheFigure.Actor(ActorName)
					  for Parm in FingerParms:
						  P = A.ParameterByCode(Parm)
						  R = FingerProp * random.random() - 0.5*FingerProp
						  P.SetValue(R+P.Value())
				  except:
					  pass

	#-----------------------------------------------------------------------------
	#-----------------------------------------------------------------------------
	def RunBlinks(self):
		# Get the selections from the ParmListBox.
		Winkers=[]
		Sels = self.ParmListBox.curselection()
		for OneSel in Sels:
			Winkers.append(self.ParmListBox.get(int(OneSel)))

		SecondsWithinBlink = 0.1  # Controlled
		# Prorate the blink length by actual frames per second.
		fps = scene.FramesPerSecond()
		# Turn Sec/Blink into Frames/Blink:
		FramesWithinHalfBlink = int(SecondsWithinBlink * float(fps) * 0.5)
		if FramesWithinHalfBlink < 2:
			FramesWithinHalfBlink = 2

		#Start the interval at nonzero, so we have a comparison the first time.
		NextActionFrame = int((BlinkVariation * random.random()) + FramesBetweenBlinks)

		for i in range((StartFrame-1),(EndFrame-1)):

		  if (i != NextActionFrame):  # Skip until NextActionFrame
			 continue

		  # Now do the blink, which involves running forward temporarily
		  # for a few frames to complete one close/open action.
		  scene.SetFrame(i)
		  FirstFrame = i - FramesWithinHalfBlink
		  MidFrame = i
		  LastFrame = i + FramesWithinHalfBlink
		  if FirstFrame < 0 or LastFrame >= (scene.NumFrames()-1): continue
		  scene.SetFrame(FirstFrame)
		  for OneWinker in Winkers:
			  P = TheHead.Parameter(OneWinker)
			  OpenVal = P.Value()
			  P.SetValue(OpenVal)
			  P.SetSplineBreak(FirstFrame,1)
		  scene.SetFrame(MidFrame) # Closed at this frame
		  for OneWinker in Winkers:
			  P = TheHead.Parameter(OneWinker)
			  P.SetValue(CloseVal)
			  P.SetSplineBreak(MidFrame,1)
		  scene.SetFrame(LastFrame)
		  for OneWinker in Winkers:
			  P = TheHead.Parameter(OneWinker)
			  P.SetValue(OpenVal)
			  P.SetSplineBreak(LastFrame,1)

		  # Set next interval with random variation.
		  #NextActionFrame = i + int((BlinkVariation * random.random()) + FramesBetweenBlinks)
		  NextActionFrame = int(float(i) + (BlinkVariation * random.random()) + FramesBetweenBlinks)

	#--------------------------------------------------------------------

	def RunGlances(self):
		# Be sure both eyes start out centered.
		scene.SetFrame(StartFrame-1)
		A = TheFigure.Actor("Left Eye")
		P = A.ParameterByCode(poser.kParmCodeYROT)
		P.SetSplineBreak(StartFrame-1,1) # Break spline before moving
		P.SetValue(0.0)  # Center the left eye
		A = TheFigure.Actor("Right Eye")
		P = A.ParameterByCode(poser.kParmCodeYROT)
		P.SetSplineBreak(StartFrame-1,1) # Break spline before moving
		P.SetValue(0.0)  # Center the right eye

		#Start the interval at nonzero, so we have a comparison the first time.
		NextActionFrame = int(random.random() + FramesBetweenGlances)

		for i in range((StartFrame-1),(EndFrame-1)):

		  if (i != NextActionFrame):  # Skip until NextActionFrame
			 continue

		  # Now do the glance, which involves running forward temporarily
		  # for a few frames to complete one off-center/return.
		  scene.SetFrame(i)
		  try:
			 OffCenterVal = (GlanceProp * random.random()) - (0.5*GlanceProp)
			 # Move both eyes to off-center position
			 A = TheFigure.Actor("Left Eye")
			 P = A.ParameterByCode(poser.kParmCodeYROT)
			 P.SetValue(OffCenterVal)
			 P.SetSplineBreak(i,1) # Break spline after opening
			 A = TheFigure.Actor("Right Eye")
			 P = A.ParameterByCode(poser.kParmCodeYROT)
			 P.SetValue(OffCenterVal)
			 P.SetSplineBreak(i,1) # Break spline after opening

			 #AheadFrame = i + int(random.random() + FramesWithinGlance)
			 AheadFrame = int(float(i) + random.random() + float(FramesWithinGlance))
			 scene.SetFrame(AheadFrame) # move ahead by length of glance

			 # Return both eyes to center position (zero)
			 A = TheFigure.Actor("Left Eye")
			 P = A.ParameterByCode(poser.kParmCodeYROT)
			 P.SetValue(0.0)
			 P.SetSplineBreak(AheadFrame,1) # Break spline after opening
			 A = TheFigure.Actor("Right Eye")
			 P = A.ParameterByCode(poser.kParmCodeYROT)
			 P.SetValue(0.0)
			 P.SetSplineBreak(AheadFrame,1) # Break spline after opening

		  except:
			 pass

		  # Set next interval with random variation.
		  #NextActionFrame = i + int((BlinkVariation * random.random()) + FramesBetweenGlances)
		  NextActionFrame = int(float(i) + (BlinkVariation * random.random()) + float(FramesBetweenGlances))

	#--------------------------------------------------------------------

	def RunBreaths(self):

		# Set the scale increment so that we will inc and dec by 0.15 when
		# Main Intensity is at default.
		# init value of Intensity = 0.2; goes from 0 to 0.4
		Increment = (0.15 / 0.2) * Intensity

		# Locate all clothing attached to this figure, so we can change the scale
		# of the shirt when breathing.	The first element in the array is the name
		# of the main figure; we add any clothing items to this so we can operate
		# on the main and the clothing in parallel.
		FigPlusClothes=[]
		FigPlusClothes.append(TheFigure.Name())

		for OneFigure in scene.Figures():
			if OneFigure.ConformTarget(): # If this item is conformed,
				if OneFigure.ConformTarget().Name() == TheFigure.Name(): # and it belongs to the main figure,
					FigPlusClothes.append(OneFigure.Name()) # add it to list.

		# Vary the z-scale of both Chest and Abdomen
		# by 1% each way from center.  If a Waist is present, vary it as well.

		#Start the interval at nonzero, so we have a comparison the first time.
		NextActionFrame = int((2.5 * random.random()) + FramesBetweenBreaths)

		for i in range((StartFrame-1),(EndFrame-1)):

		  if (i != NextActionFrame):  # Skip until NextActionFrame
			 continue

		  # Now do the breath, which involves running forward temporarily
		  # for a few frames to complete one close/open action.
		  scene.SetFrame(i)
		  for FigName in FigPlusClothes:
			  try:
				 A = scene.Figure(FigName).Actor("Chest")
				 P = A.ParameterByCode(poser.kParmCodeZSCALE)
				 P.SetValue(P.Value() + Increment)
				 A = scene.Figure(FigName).Actor("Abdomen")
				 P = A.ParameterByCode(poser.kParmCodeZSCALE)
				 P.SetValue(P.Value() + Increment)
				 A = scene.Figure(FigName).Actor("Waist")
				 P = A.ParameterByCode(poser.kParmCodeZSCALE)
				 P.SetValue(P.Value() + Increment)
			  except:
				 pass

		  #AheadFrame = i + (0.5*FramesBetweenBreaths)
		  AheadFrame = int(float(i) + 0.5*FramesBetweenBreaths)
		  scene.SetFrame(AheadFrame) # move ahead by half cycle
		  for FigName in FigPlusClothes: # Same thing but subtract
			  try:
				 A = scene.Figure(FigName).Actor("Chest")
				 P = A.ParameterByCode(poser.kParmCodeZSCALE)
				 P.SetValue(P.Value() - Increment)
				 A = scene.Figure(FigName).Actor("Abdomen")
				 P = A.ParameterByCode(poser.kParmCodeZSCALE)
				 P.SetValue(P.Value() - Increment)
			  except:
				 pass

		  # Set next interval with random variation.
		  #NextActionFrame = i + int((2.5 * random.random()) + FramesBetweenBreaths)
		  NextActionFrame = int(float(i) + (2.5 * random.random()) + FramesBetweenBreaths)

	# - - - - - - - - - - - - - - - - - -
	# - - - - - - - - - - - - - - - - - -

	def HandleGo(self):
		self.GetControls()
		self.ShowStatus("Working...")
		SetupVars()

		self.RunNaturalizer()

		if BlinksOn:
			self.RunBlinks()
		if GlanceOn:
			self.RunGlances()
		if BreathOn:
			self.RunBreaths()

		scene.SetFrame(0) # For niceynice
		self.ShowStatus("Done.")

	# - - - - - - - - - - - - - - - - - -

	def HandleCancel(self):
		self.master.destroy()

#------------------------------------------------------------
# Activate the Win loop, which will be broken by any button.
#------------------------------------------------------------

root = Tk()
app = App(root, '')
root.mainloop()

#-----------------------------------------------------------------------------
#--------------------------------------------------------------------
